#define CPU_ROM_BASE							0x10000000	//2MB of ROM (in ram)
#define CPU_ROM_SIZE							0x00200000

#define CPU_DYN_RAM_BASE						0x28000000	//12M of dyn ram
#define CPU_DYN_RAM_SIZE						0x00c00000
#define CPU_DYN_RAM_PA							0xa0400000

#define CPU_STORAGE_RAM_BASE					0x30000000	//47M of storage ram
#define CPU_STORAGE_RAM_SIZE					0x02f00000
#define CPU_STORAGE_RAM_PA						0xa1000000

#define CPU_HARDWIRED_VRAM_ADDR					0x70000000	//324x484*2 plus clut 256x2 slop
#define CPU_HARDWIRED_VRAM_SIZE					0x00050000
#define CPU_HARDWIRED_VRAM_PA					0xa3f00000

#define CPU_CACHE_CLEAN_BASE					0xf0000000	//mapped to nowhere
#define CPU_CACHE_CLEAN_SIZE					0x00100000
#define CPU_CACHE_CLEAN_PA						0xf0000000

#define CPU_PAGETABLE_BASE						0xffff0000	//pagetables, vectors, tls
#define CPU_PAGETABLE_SIZE						0x00010000
#define CPU_PAGETABLE_PA						0xa3f50000

#define CPU_KERNEL_GLOBALS_BASE					0xfff00000
#define CPU_KERNEL_GLOBALS_SIZE					0x000a0000
#define CPU_KERNEL_GLOBALS_PA					0xa3f60000

//for identity map at bringup
#define CPU_IDENT_MAP_1_BASE					0xa0000000
#define CPU_IDENT_MAP_1_SIZE					0x04000000

#define CPU_IDENT_MAP_2_BASE					0x00000000
#define CPU_IDENT_MAP_2_SIZE					0x01000000



