#ifndef _PACE_H_
#define _PACE_H_

typedef void*	EmulStateRef;


EmulStateRef PceGetSystemEmulState(void);
EmulStateRef PceGetCurrentAppEmulState(void);
UInt8 PceReadInt8From68KStack(EmulStateRef emulState, Int32 offset);
UInt16 PceReadInt16From68KStack(EmulStateRef ref, Int32 offset);
UInt32 PceReadInt32From68KStack(EmulStateRef ref, Int32 offset);
UInt32 PceReadInt32From68KMemory(EmulStateRef ref, UInt32* val, Int32 offset);
void *PceReadZeroOrPtrFrom68KStack(EmulStateRef emulState, Int32 offset);
void *PceReadPtrFrom68KStack(EmulStateRef emulState, Int32 offset);
void PceWriteInt32To68KMemory(EmulStateRef ref, UInt32* val, Int32 offset, UInt32 newVal);
void PceWriteInt16To68KMemory(EmulStateRef ref, UInt16* val, Int32 offset, UInt16 newVal);
void PceWriteInt8To68KMemory(EmulStateRef ref, UInt8* val, Int32 offset, UInt8 newVal);
void PceSet68KInt8ReturnResult(EmulStateRef ref, UInt8 val);
void PceSet68KInt16ReturnResult(EmulStateRef ref, UInt16 val);
void PceSet68KPtrReturnResult(EmulStateRef ref, void* ptr);
void PceSet68KInt32ReturnResult(EmulStateRef ref, UInt32 val);
UInt8 PceGet68KInt8ReturnResult(EmulStateRef ref);
void PceWriteInt32To68KStack(EmulStateRef emulState, Int32 offset, UInt32 value);
Err PceCall68KRoutine(EmulStateRef emulState, void *procP, UInt32 argsSize);
Err PceWriteStructureTo68KMemory(EmulStateRef ref, const void* srcStruct, void* dstStruct,const UInt8* format);
Err PceReadStructureFrom68KMemory(EmulStateRef ref, void* dstStruct, const void* srcStruct,const UInt8* format);

#endif