#ifndef _RAL_EXPORT_H_
#define _RAL_EXPORT_H_



#define REPALM_TABLE										0x14	//[R9, #-0x14]

//base traps available to all start at 0x00
#define REPALM_FUNC_IDX_GET_CLOCK_RATE						0x00
#define REPALM_FUNC_IDX_GET_TIMER_VAL						0x01
#define REPALM_FUNC_IDX_GET_ADC_VALUE						0x02
#define REPALM_FUNC_IDX_PWR_CTL								0x03

//machine-specific traps start at 0x40

//only on legacy-mmu platforms
	#define REPALM_FUNC_IDX_PLAT_PERIPH_P2V					0x40
	#define REPALM_FUNC_IDX_DMA_BUF_ALLOC					0x41
	#define REPALM_FUNC_IDX_DMA_BUF_FREE					0x42

//only on hw "virtual"
	#define REPALM_FUNC_IDX_HYPER_FORWARDER					0x40

//common to all remoteio devices
	#define REPALM_FUNC_IDX_REMOTEIO_UPDATE_START			0x40
	#define REPALM_FUNC_IDX_REMOTEIO_COPY_TO_SRAM			0x41
	#define REPALM_FUNC_IDX_REMOTEIO_COPY_FROM_SRAM			0x42
	#define REPALM_FUNC_IDX_REMOTEIO_SER_INIT				0x43
	#define REPALM_FUNC_IDX_REMOTEIO_SER_OP					0x44
	#define REPALM_FUNC_IDX_REMOTEIO_SER_TX					0x45
	#define REPALM_FUNC_IDX_REMOTEIO_SER_DEINIT				0x46
	#define REPALM_FUNC_IDX_REMOTEIO_GET_BUF_SZS			0x47

//only on RP2040-PalmCard
	#define REPALM_FUNC_IDX_SDIO_SET_SPEED					0x40
	#define REPALM_FUNC_IDX_SDIO_CMD						0x41
	#define REPALM_FUNC_IDX_SDIO_BUSY_WAIT					0x42
	#define REPALM_FUNC_IDX_SDIO_DATA_RX					0x43
	#define REPALM_FUNC_IDX_SDIO_DATA_TX					0x44
	#define REPALM_FUNC_IDX_SDIO_INSERT_NOTIF_CFG			0x45
	
	#define REPALM_FUNC_IDX_UART_CONFIG						0x48
	#define REPALM_FUNC_IDX_UART_TX							0x49
	#define REPALM_FUNC_IDX_UART_GET_STA					0x4a
	
	#define REPALM_FUNC_SPI_FLASH_OP						0x4f

//only on RP2040-Waveshare
	#define REPALM_FUNC_IDX_GET_SD_PIO_INFO					0x40

//68k traps follow the same pattern, just added to sysLibTrapCustom

#endif

